![Stardust Engine](./stardustLogo.png)

Mission: A brand new, easy to use, fast, Unity-like game engine for the PSP, Windows, Linux, Mac. (Experimental support for PS2/PS Vita coming soon!)

## Project Phase
The engine is currently in rapid development. As such, there is documentation on stable parts, but not so much the bleeding edge. The project is compilable and is being used in multiple projects including Minecraft-PSP (Project Raven & its components) and PSP-Chat (among others). The current API is very data driven and relies on programmers to fill the gaps between artwork, data, and more. The majority of features of this engine are somewhat self-explanatory, but still require documentation.

## The Engine
The engine aims to be designed similar in architecture to Unity3D and features many similarities. Many of these similarities include GameObjects, Components, and Extensible Scripting. 

The engine will come in 3 options, each more powerful than the previous (and in reverse order of release).

The first option is a full editor with graphical interface that can be used to make a playable game with very minimal scripting required.
The second option is an interpreter with full scripting support that can be used to make quick and effective games with little to no experience required.
The third option is a highly performant and fast C++ API that can be used for complete control and efficiency.

The engine is broken up into multiple submodules that make up the engine, and the following are those key sub-components:

- Math - Done
- Utilities - Done
- Events - Done
- Networking - Done
- Core Engine - Done
- Scene Management - Done
- Profiling - Done
- Audio - Done
- Rendering - Done
- Sprites - Done
- 2D Lighting - Done
- UI - Done
- 2D Controllers - Done
- 2D Physics - Done
- Animations - Done for 2D
- 3D Rendering - Done*
- 3D Lighting
- 3D Physics
- 3D Controllers
- Particles
- Scripting
- Editor
- Post Processing
- Cross Platform - In progress

## Schedule
The schedule is work in progress...

Current Schedule:
* v0.6 - Model Loading, Lighting, Billboards, Particles
* v0.7 - Terrain, Shadows, Reflections
* v0.8 - 3D Physics & Audio
* v0.9 - Scripting (Lua/LuaJIT)
* v1.0 - Editor
* v1.1 - Post Processor
